
-- Status: 04.02.2017

-------------------------------------------------------------
--- GET NUMBER OF FILES PER FILE EXTENSION PER REPOSITORY ---
-------------------------------------------------------------
SELECT
  repos.repo_name as repo_name,
  repos.repo_language as repo_language,
  LOWER(REGEXP_EXTRACT(files.path, r'(\.[^.]+$)')) as file_ext,
  COUNT(files.id) as file_count
FROM
  [bigquery-public-data:github_repos.files] files
INNER JOIN
  [msr17-snippets:gh.repos] repos
ON
  files.repo_name = repos.repo_name
GROUP BY repo_name, repo_language, file_ext;

=> gh.repos_all_file_ext_all


SELECT file_ext, SUM(file_count) as file_count
FROM [msr17-snippets:gh.repos_all_file_ext_all]
GROUP BY file_ext
HAVING file_count>=10000
ORDER BY file_count DESC;

=> gh.repos_all_file_ext_all_ranking_10000